/*
 * Copyright (C) 2020-2021 Aloysius Indrayanto
 *
 * This file is part of the eCxx library, see LICENSE file for the license details.
 */

/*
 * ----------------------------------------------------------------------------------
 * The code in this file is copied (with a slight modifications) from:
 *     StreamString.cpp
 * ----------------------------------------------------------------------------------
 * Copyright (C) 2015 Markus Sattler. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under the
 * terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; either version 2.1 of the License, or (at your option) any later
 * version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 51
 * Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 * ----------------------------------------------------------------------------------
 */


#include "CoreSys.h"
#include "StreamString.h"


namespace eCxx {

namespace NodeMCU {


int32_t StreamString::available()
{ return length(); }


int32_t StreamString::read()
{
    if( !length() ) return -1;

    const char c = charAt(0);
    remove(0, 1);

    return c;
}


int32_t StreamString::peek()
{
    if( !length() ) return -1;

    const char c = charAt(0);

    return c;
}


size_t StreamString::write(uint8_t data)
{ return concat( static_cast<char>(data) ); }


size_t StreamString::write(const uint8_t* data, size_t size)
{
    if( !size || !data ) return 0;

    const uint32_t newlen = length() + size;

    if( reserve(newlen + 1) ) {
        memcpy(wbuffer() + len(), data, size);
        setLen(newlen);
        *(wbuffer() + newlen) = 0x00; // Add null terminator
        return size;
    }

    DEBUGV("StreamString::write() OOM (%d->%d)\n", length(), newlen + 1);
    return 0;
}


void StreamString::flush()
{}


} // namespace NodeMCU

} // namespace eCxx
